<?php
/* Namazu ץ PHP */
$idxname='/usr/var/namazu/index';

if(!extension_loaded('namazu')){
	if(!dl('namazu.so')){
		echo 'error';
		exit;
	}
}
if(empty($max)){
	$max = 20;
}else{
	$max = (int)$max;
}
if($max <= 0){
	$max = 20;
}
if($max > 1000){
	$max = 1000;
}
if($max <= 10){
	$nmax = 0;
}else if($max <= 20){
	$nmax = 1;
}else if($max <= 30){
	$nmax = 2;
}else if($max <= 50){
	$nmax = 3;
}else{
	$nmax = 4;
}
$bresult = 1;
if(!empty($result)){
	if($result == 'short'){
		$bresult = 0;
	}
}
$nsort = 0;
nmz_set_sortmethod('score');
nmz_set_sortorder('descending');
if(!empty($sort) && strlen($sort) < 100){
	if($sort == 'score'){
		$nsort = 0;
	}else if($sort == 'date:late'){
		nmz_set_sortmethod('date');
		$nsort = 1;
	}else if($sort == 'date:early'){
		nmz_set_sortmethod('date');
		nmz_set_sortorder('ascending');
		$nsort = 2;
	}else{
		$array = explode(':',$sort);
		if(count($array) >= 3 && $array[0] == 'field'){
			if($array[1] == 'subject'){
				$nsort = 4;
				nmz_set_sortmethod('field:subject');
			}else if($array[1] == 'from'){
				$nsort = 6;
				nmz_set_sortmethod('field:from');
			}else if($array[1] == 'size'){
				$nsort = 8;
				nmz_set_sortmethod('field:size');
			}else{
				$nsort = 10;
				nmz_set_sortmethod('field:uri');
			}
			if($array[2] == 'ascending'){
				nmz_set_sortorder('ascending');
				$nsort--;
			}
		}
	}
}

if(empty($key)){
	$nhit = -1;
	$key = '';
}else if(strlen($key) > 200){
	$nhit = -2;
	$key = '';
}else{
	$nhit = -3;
	$nmzid = nmz_open($idxname);
	if($nmzid){
		$hlist = nmz_search($nmzid,$key);
		if($hlist){
			$nhit = nmz_num_hits($hlist);
		}
	}
}

$str = $idxname . '/NMZ.status';
$fd = fopen($str, 'r');
if($fd){
	$idxfiles = trim(strchr(fgets($fd, 200),' '));
	$idxkeys = trim(strchr(fgets($fd, 200),' '));
	fclose($fd);
	$ts = filectime($str);
	if($ts){
		$idxdate = date('Y/m/d',$ts);
	}else{
		$idxdate = '';
	}
}else{
	$idxfiles = '';
	$idxkeys = '';
	$idxdate = '';
}

$selected = 'selected ';

?>
<html>
<head>
<title>Namazu the full text retrieval search system: &lt;<?php echo htmlspecialchars($key); ?>&gt;</TITLE>
</head>
<body>
<h1>Namazu ˤʸƥ</h1>
<p>
ߡ<?php echo $idxfiles; ?> Υե뤬ǥå졢
 <?php echo $idxkeys; ?> ĤΥɤϿƤޤ
</p>
<p>
<strong>ǥåκǽ: <?php echo $idxdate; ?></strong>
</p>

<hr>
<form method="post" action="<?php echo $PHP_SELF; ?>">
<p>
<strong>:</strong> 
<input type="text" name="key" SIZE="40" VALUE="<?php echo $key ?>">
<input type="submit" name="submit" VALUE="Search!">
</p>
<p>
<strong>ɽ:</strong>
<select name="max">
<option <?php if($nmax <= 0){ echo $selected;} ?>value="10">10
<option <?php if($nmax == 1){ echo $selected;} ?>value="20">20
<option <?php if($nmax == 2){ echo $selected;} ?>value="30">30
<option <?php if($nmax == 3){ echo $selected;} ?>value="50">50
<option <?php if($nmax >= 4){ echo $selected;} ?>value="100">100
</select>
<strong>ɽ:</strong>
<select name="result">
<option <?php if($bresult){ echo $selected;} ?>value="normal">ɸ
<option <?php if(!$bresult){ echo $selected;} ?>value="short">ʷ
</select>
<strong>:</strong>
<select name="sort">
<option <?php if($nsort == 0){ echo $selected;} ?>value="score">
<option <?php if($nsort == 1){ echo $selected;} ?>value="date:late"> ()
<option <?php if($nsort == 2){ echo $selected;} ?>value="date:early"> (Ť)
<option <?php if($nsort == 3){ echo $selected;} ?>value="field:subject:ascending">̾ ()
<option <?php if($nsort == 4){ echo $selected;} ?>value="field:subject:descending">̾ (߽)
<option <?php if($nsort == 5){ echo $selected;} ?>value="field:from:ascending"> ()
<option <?php if($nsort == 6){ echo $selected;} ?>value="field:from:descending"> (߽)
<option <?php if($nsort == 7){ echo $selected;} ?>value="field:size:ascending"> ()
<option <?php if($nsort == 8){ echo $selected;} ?>value="field:size:descending"> (߽)
<option <?php if($nsort == 9){ echo $selected;} ?>value="field:uri:ascending">URI ()
<option <?php if($nsort == 10){ echo $selected;} ?>value="field:uri:descending">URI (߽)
</select>
</p>
</form>

<hr>
<h2></h2>
<?php
if($nhit >= 0){
	echo '<p><strong>˥ޥå ' . $nhit . ' Ĥʸ񤬸Ĥޤ</strong></p>
';
	$n = $nhit;
	if ($n > $max) {
		$n = $max;
	}

$ts = microtime();

	echo '<dl>
';

	for ($i = 0; $i < $n; $i++){
		echo '<dt>' . ($i+1) . '. <strong><a href="'
 . nmz_result_field($hlist,$i,'uri') . '">'
 . htmlspecialchars(nmz_result_field($hlist,$i,'subject')) . '</a></strong> (score:'
 .  nmz_result_score($hlist,$i) . ')
<dd><strong>From</strong>:<em>' . htmlspecialchars(nmz_result_field($hlist,$i,'from')) . '</em><br>
<strong>Date</strong>:<em>' . nmz_result_field($hlist,$i,'date') . '</em><br>
';
		if($bresult){
			echo '<dd>' . htmlspecialchars(nmz_result_field($hlist,$i,'summary')) . '
';
		}
		echo '<dd> size (' . nmz_result_field($hlist,$i,'size') . ' bytes)<br><br>

';
	}

	echo '</dl>';

$te = microtime();
$tsa = explode(' ', $ts);
$tea = explode(' ', $te);
echo '
<hr>' . ($tea[1] + $tea[0] - $tsa[1] - $tsa[0]);

}else if($nhit == -1){
	echo '<strong>empty query</strong>';
}else if($nhit == -2){
	echo '<strong>too long query</strong>';
}else{
	echo '<strong>Search failure</strong>';
}

if($nhit >= 0 && !empty($hlist)){
	nmz_free_result($hlist);
}
if($nhit >= 0 && !empty($nmzid)){
	nmz_close($nmzid);
}
?>


<hr>
</html>
</body>
