[APC]
; Alternative PHP Cache
zend_extension="/opt/php4/lib/php/extensions/no-debug-non-zts-20020429/apc.so"
;
; APC Cache mode
;
; Sets the operating mode of the APC cache.
;        off: for switching off the APC (default)
;        shm: for using APC in shared memory mode
;        mmap: for using APC in memory mapped files mode
apc.mode=mmap
;
; cache_rt  defines the cache retrieval policy.  safe is the default
;        supported: (S)
;        default: safe
;	safe: global locks are taken around all cache retrievals
;	fast: uses an optimistic cache address cacheing to avoid global locks
;apc.cache_rt=
;
; cachedir  sets the top-level dir under which to write compiled php files.
;        supported: (M)
;        default: NULL
apc.cachedir=/opt/php4/cache
;
; hash_buckets  sets the number of hash_buckets in the master index.  
;        supported: (S)
;        default: 1024
;apc.hash_buckets=
;
; regex  is a colon delimited list of POSIX extended regex of files NOT to cache.
;        supported: (M,S)
;        default: NULL
;        example: apc.regex="no_cache.inc:bad_file.inc"
;apc.regex="*.inc"
;
; shm_segment_size  sets the size of sysv shared memory segments to use in bytes.
;        supported: (S)
;        default: 33554431
;apc.shm_segment_size=
;
; ttl  sets a global ttl on all cache objects. 
;     Objects not updated in ttl seconds will be expired and delted.
;        supported: (M,S)
;        default: 0
;        values: {0,1}
;apc.ttl=
;
; check_mtime  specifies whether a source file should be re-compiled
;             if it has been modified since it was last compiled.
;        supported: (S)
;        default: 0
;        values: {0,1}
;apc.check_mtime=1
;
; relative_includes  specifies whether a relative paths may be passed
;                   to the PHP file inclusion functions.
;        supported: (M,S)
;        default: 1
;        values: {0,1}
;apc.relative_includes=
;
; check_compiled_source  specifies whether or not to check to see 
;                       if the php source file you are reading is actually 
;                       a compiled file.
;        supported: (M,S)
;        default: 0
;        values: {0,1}
apc.check_compiled_source=1
;
